mostly profanity and fixes
[distro-setup] / brc
diff --git a/brc b/brc
index 24a437cd4afebc0969ea06bd8b54e3cbfc9fd576..b2df5c28bcd8aa102fc4eef73ca43b69b379610e 100644 (file)
--- a/brc
+++ b/brc
@@ -5,11 +5,19 @@
 
 # Use source ~/.bashrc instead of doing bash -l when running a script
 # so this can set extdebug and avoid the bash debugger.
+
+
 if [[ -s /a/bin/errhandle/err ]]; then
-  source /a/bin/errhandle/err
-elif [[ -s $bashrc_dir/err ]]; then
   # shellcheck source=/a/bin/errhandle/err
-  source $bashrc_dir/err
+  source /a/bin/errhandle/err
+  # wtf, shellcheck doesn't allow disabling warnings in elifs
+else
+  # bleh shellcheck can't handle disabling in an elif, so nesting this if.
+  # shellcheck disable=SC2154 # set in .bashrc
+  if [[ -s $bashrc_dir/err ]]; then
+    # shellcheck source=/a/bin/errhandle/err
+    source $bashrc_dir/err
+  fi
 fi
 
 # In t8, it runs clear_console for login shells by default. I don't want
@@ -224,6 +232,7 @@ export PROFILE_TASKS_TASK_OUTPUT_LIMIT=100
 # i for insensitive. the rest from
 # X means dont remove the current screenworth of output upon exit
 # R means to show colors n things
+# a useful flag is -F aka --quit-if-one-screen
 export LESS=RXij12
 export SYSTEMD_LESS=$LESS
 
@@ -260,16 +269,16 @@ if [[ $SOE ]]; then
 fi
 
 
-
-
 mysrc() {
   local path dir file
   path=$1
   dir=${path%/*}
   file=${path##*/}
   if [[ -s $path ]]; then
+    # shellcheck disable=SC1090 # this is dynamic, shellcheck can't follow it.
     source $path
   elif [[ -s $bashrc_dir/$file ]]; then
+    # shellcheck disable=SC1090 # this is dynamic, shellcheck can't follow it.
     source $bashrc_dir/$file
   fi
 }
@@ -278,6 +287,16 @@ mysrc() {
 mysrc /a/bin/small-misc-bash/ll-function
 mysrc /a/bin/distro-functions/src/package-manager-abstractions
 
+# things to remember:
+# ALT-C - cd into the selected directory
+# CTRL-T - Paste the selected file path into the command line
+#
+# good guide to some of its basic features is the readme file
+# https://github.com/junegunn/fzf
+
+# if [[ -s /usr/share/doc/fzf/examples/key-bindings.bash ]]; then
+#   source /usr/share/doc/fzf/examples/key-bindings.bash
+# fi
 
 # * functions
 
@@ -301,8 +320,8 @@ ccomp() {
     c=$(complete -p $src 2>/dev/null) || return 0
   fi
   # remove $src( .*|$)
-  c=${c% $src}
-  c=${c%% $src *}
+  c=${c% "$src"}
+  c=${c%% "$src" *}
   eval $c $*
 }
 
@@ -440,7 +459,7 @@ cl() {
     tac ~/.cdirs | awk '!seen[$0]++' | head -n 200 | tac | sponge ~/.cdirs || [[ $? == 141 ]]
   fi
 
-  for (( j=$start; j >= 0; j-- )); do
+  for (( j=start; j >= 0; j-- )); do
     line="${lines[$j]}"
     if [[ ! $line || ${alines[$line]} || ! -d "$line" || $line == "$PWD" || line == "$HOME"  ]]; then
       continue
@@ -475,7 +494,7 @@ bl() {
   fi
   j=1
   if (( start >= 0 )); then
-    for (( i=$start; i >= 0 ; i-- )); do
+    for (( i=start; i >= 0 ; i-- )); do
       printf "%s %s\n" $j ${_dir_back[i]}
       j=$(( j + 1 ))
       if (( j >= max )); then
@@ -496,7 +515,7 @@ bl() {
   fi
   echo --
   j=1
-  for (( i=$start; i >= 0 ; i-- )); do
+  for (( i=start; i >= 0 ; i-- )); do
     printf "%s %s\n" $j ${_dir_forward[i]}
     j=$(( j + 1 ))
     if (( j >= max )); then
@@ -524,7 +543,7 @@ pd() {
   "$@" |& pee cat "logger -t $tag" || ret=$?
   echo "exited with status=$ret" | pee cat "logger -t $tag"
   # this avoids any err-catch
-  (( $ret == 0 )) || return $ret
+  (( ret == 0 )) || return $ret
 }
 ccomp time pd
 
@@ -572,7 +591,7 @@ jdo() {
   unset jr_pid
   fg &>/dev/null ||:
   # this avoids any err-catch
-  (( $ret == 0 )) || return $ret
+  (( ret == 0 )) || return $ret
 }
 ccomp time jdo
 #### end fsf section
@@ -598,7 +617,7 @@ chere() {
 # file cut copy and paste, like the text buffers :)
 # I havnt tested these.
 _fbufferinit() { # internal use
-  ! [[ $my_f_tempdir ]] && my_f_tempdir=$(mktemp -d)
+  ! [[ $my_f_tempdir ]] && my_f_tempdir="$(mktemp -d)"
   rm -rf "${my_f_tempdir:?}"/*
 }
 fcp() { # file cp
@@ -630,8 +649,7 @@ _khfix_common() {
     ip_entry=$ip
     host_entry=$host
   fi
-  tmpfile=$(mktemp)
-  if [[ $host != $ip ]]; then
+  if [[ $host != "$ip" ]]; then
     key=$(ssh-keygen -F "$host_entry" -f $file | sed -r 's/^.*([^ ]+ +[^ ]+) *$/\1/')
     if [[ $key ]]; then
       grep -Fv "$key" "$file" | sponge "$file"
@@ -653,6 +671,33 @@ khcopy() {
   ssh-copy-id $1
 }
 
+# ya, hacky hardcoded hostnames in 2023. we could do better
+hssh-update() {
+  local -a failed_hosts hosts
+  case $HOSTNAME in
+    sy|kd)
+      hosts=(
+        kd x3.office.fsf.org syw
+      )
+      ;;
+    x3)
+      hosts=(
+        b8.nz sywg.b8.nz
+      )
+      ;;
+  esac
+  for host in ${hosts[@]}; do
+    e $host
+    if ! scp /b/fai/fai/config/files/usr/local/bin/hssh/IANK root@$host:/usr/local/bin/hssh; then
+      failed_hosts+=($host)
+    fi
+  done
+  if (( ${#failed_hosts[@]} >= 1 )); then
+    echo failed_hosts=${failed_hosts[*]}
+    return 1
+  fi
+}
+
 a() {
   local x
   x=$(readlink -nf "${1:-$PWD}")
@@ -667,33 +712,56 @@ for field in {1..20}; do
 done
 # h1 = head -n1
 for num in {1..9}; do
-  eval h$num"() { head -n$num; }"
+  eval h$num"() { head -n$num || [[ \$? == 141 ]]; }"
 done
 
 
 hexipv4() {
+  # shellcheck disable=SC2046 disable=SC2001 disable=SC2183 # hacks, expected
   printf '%d.%d.%d.%d\n' $(echo $1 | sed 's/../0x& /g')
 }
 
 vp9() {
-  local f out outdir in
+  local f out outdir in fname origdir skip1
+  origdir="$PWD"
   outdir=vp9
-  case $1 in
-    --out)
-      outdir=$2
-      shift 2
-      ;;
-  esac
+  skip1=false
+  while [[ $1 == -* ]]; do
+    case $1 in
+      # if we got interrupted after 1st phase
+      -2)
+        skip1=true
+        shift
+        ;;
+      --out)
+        outdir=$2
+        shift 2
+        ;;
+    esac
+  done
   m mkdir -p $outdir
+  # first pass only uses about 1 cpu, so run in parallel
   for f; do
-    out=$PWD/$outdir/$f
-    in=$PWD/$f
-    m cd $(mktemp -d)
-    pwd
-    m ffmpeg -threads 0 -i $in -g 192 -vcodec libvpx-vp9 -vf scale=-1:720 -max_muxing_queue_size 9999  -b:v 750K -pass 1 -an -f null /dev/null
-    m ffmpeg -y -threads 0 -i $in -g 192 -vcodec libvpx-vp9 -vf scale=-1:720 -max_muxing_queue_size 9999 -b:v 750K -pass 2 -c:a libvorbis -qscale:a 5 $out
-    cd -
+    {
+      fname="${f##*/f}"
+      if [[ $f == /* ]]; then
+        in="$f"
+      else
+        in=$origdir/$f
+      fi
+      out="$origdir/$outdir/$fname"
+      mkdir -p /tmp/vp9/$fname
+      cd /tmp/vp9/$fname
+      if ! $skip1 && [[ ! -s ffmpeg2pass-0.log ]]; then
+        # -nostdin or else wait causes ffmpeg to go into stopped state. dunno why, random stackoverflow answer.
+        m ffmpeg -nostdin -hide_banner -loglevel error -i $in -g 192 -vcodec libvpx-vp9 -vf scale=-1:720 -max_muxing_queue_size 9999  -b:v 750K -pass 1 -an -f null /dev/null
+      fi
+      if [[ -e $out ]]; then rm -f $out; fi
+      m ffmpeg -nostdin -hide_banner -loglevel error -y -i $in -g 192 -vcodec libvpx-vp9 -tile-rows 2 -vf scale=-1:720 -max_muxing_queue_size 9999 -b:v 750K -pass 2 -c:a libvorbis -qscale:a 5 $out
+    } &
   done
+  wait -f
+  cd "$origdir"
 }
 
 utcl() { # utc 24 hour time to local hour 24 hour time
@@ -866,6 +934,8 @@ ccomp bg d
 z() { builtin fg "$@"; }
 ccomp fg z
 
+x() { builtin kill %%; }
+
 dc() {
   diff --strip-trailing-cr -w "$@"   # diff content
 }
@@ -946,13 +1016,18 @@ digdiff() {
   diff -u /tmp/digdiff <(digsort $s2 "$@")
 }
 
+# date in a format i like reading
 dt() {
   date "+%A, %B %d, %r" "$@"
 }
 dtr() {
   date -R "$@"
 }
-ccomp date dt dtr
+# date with all digits in a format i like
+dtd() {
+  date +%F_%T% "$@"
+}
+ccomp date dt dtr dtd
 
 dus() { # du, sorted, default arg of
   du -sh ${@:-*} | sort -h
@@ -994,6 +1069,7 @@ ediff() {
 }
 
 # mail related
+# shellcheck disable=SC2120 # we expect to pass arguments in use outside this file
 etail() {
   ngset
   tail -F /var/log/exim4/mainlog /var/log/exim4/*main /var/log/exim4/paniclog /var/log/exim4/*panic -n 200 "$@"
@@ -1007,7 +1083,14 @@ etail2() {
 }
 ccomp tail etail etail2
 
+# ran into this online, trying it out
+detach() {
+  ( "$@" &>/dev/null & disown )
+}
 
+showkeys() {
+  ssh "$@" cat .ssh/authorized_keys{,2}
+}
 
 
 # print exim old pids
@@ -1020,7 +1103,7 @@ eoldpids() {
   fi
   for pid in $(pgrep -f '^/usr/sbin/exim4( |$)'); do
     # the daemonpid gets reexeced on HUP (service reloads), keeping its same old timestamp
-    if [[ $pid == $daemonpid ]]; then
+    if [[ $pid == "$daemonpid" ]]; then
       continue
     fi
     piduptime=$(awk -v ticks="$(getconf CLK_TCK)" 'NR==1 { now=$1; next } END { printf "%9.0f\n", now - ($20/ticks) }' /proc/uptime RS=')' /proc/$pid/stat) ||: # sometimes pids disappear pretty fast
@@ -1044,12 +1127,13 @@ etailnew() {
 }
 # exim watch as old pids go away
 ewatchold() {
-  local configtime pid piduptime now
+  local configtime pid piduptime now tmpstr
   local -i count
   local -a oldpids
   count=0
   while true; do
-    oldpids=($(eoldpids))
+    tmpstr=$(eoldpids)
+    mapfile -t oldpids <<<"$tmpstr"
     if (( ! ${#oldpids[@]} )); then
       return
     fi
@@ -1094,6 +1178,20 @@ econfdev() {
   update-exim4.conf -d /tmp/edev/etc/exim4 -o /tmp/edev/e.conf
 }
 
+# exim grep in
+# show important information about incoming mail in the exim log
+egrin() {
+  sed -rn '/testignore|jtuttle|eximbackup/!s/^[^ ]+ ([^ ]+) [^ ]+ [^ ]+ <= ([^ ]+).*T="(.*)" from (<[^ ]+> .*$)/\1 \4\n \3/p' <${1:-/var/log/exim4/mainlog}
+}
+
+# 2nd line is message-id:
+egrinid() {
+  sed -rn '/testignore|jtuttle|eximbackup/!s/^[^ ]+ ([^ ]+) [^ ]+ [^ ]+ <= ([^ ]+).* id=([^ ]+) T="(.*)" from (<[^ ]+> .*$)/\1 \5\n \3\n \4/p' <${1:-/var/log/exim4/mainlog}
+}
+etailin() {
+  tail -F /var/log/exim4/mainlog | sed -rn '/testignore|jtuttle|eximbackup/!s/^[^ ]+ ([^ ]+) [^ ]+ [^ ]+ <= ([^ ]+).*T="(.*)" from (<[^ ]+> .*$)/\1 \4\n \3/p'
+}
+
 
 
 
@@ -1112,12 +1210,75 @@ faf() { # find all files. use -L to follow symlinks
        -o -name .undo-tree-history -prune \) -type f 2>/dev/null
 }
 
-# full path without resolving symlinks
+# usage ffconcat FILES_TO_CONCAT OUTPUT_FILE
+ffconcat() {
+  local tmpf
+  tmpf=$(mktemp)
+  printf "file '%s'\n" "$1" >$tmpf
+  while (( $# > 1 )); do
+    shift
+    printf "file '%s'\n" "$1" >>$tmpf
+  done
+  # https://trac.ffmpeg.org/wiki/Concatenate
+  ffmpeg -f concat -safe 0 -i $tmpf -c copy "$1"
+  rm $tmpf
+}
+ffremux() {
+  local tmpf tmpd
+  if (( $# == 0 )); then
+    echo ffremux error expected args >&2
+    return 1
+  fi
+  tmpd="$(mktemp -d)"
+  for f; do
+    tmpf=$tmpd/"${f##*/}"
+    ffmpeg -i "$f" -c:v copy -c:a copy $tmpf
+    cat $tmpf >"$f"
+  done
+  rm -r $tmpd
+}
+
+
+
+# absolute path of file/dir without resolving symlinks.
+#
+# Most of the time, I want this where I would normally use readlink.
+# This is what realpath -s does in most cases, but sometimes it
+# actually resolves symlinks, at least when they are in /.
+#
+# Note, if run on a dir, if the final component is relative, it won't
+# resolve that. Use the below fpd for that.
+#
+# note: we could make a variation of this which
+# assigns to a variable name using eval, so that we don't have to do
+# x=$(fp somepath), which might save subshell overhead and look nice,
+# but I'm not going to bother.
 fp() {
-  local dir base
-  base="${1##*/}"
-  dir="${1%$base}"
-  printf "%s/%s\n" $(cd $dir; pwd) "$base"
+  local initial_oldpwd initial_pwd dir base
+  initial_oldpwd="$OLDPWD"
+  initial_pwd="$PWD"
+  if [[ $1 == */* ]]; then
+    dir="${1%/*}"
+    base="/${1##*/}"
+    # CDPATH because having it set will cause cd to possibly print output
+    CDPATH='' cd "$dir"
+    printf "%s%s\n" "$PWD" "$base"
+    CDPATH='' cd "$initial_pwd"
+    OLDPWD="$initial_oldpwd"
+  else
+    printf "%s/%s\n" "$PWD" "$1"
+  fi
+}
+# full path of directory without resolving symlinks
+fpd() {
+  local initial_oldpwd initial_pwd dir
+  initial_oldpwd="$OLDPWD"
+  initial_pwd="$PWD"
+  dir="$1"
+  CDPATH='' cd "$dir"
+  printf "%s%s\n" "$PWD" "$base"
+  cd "$initial_pwd"
+  OLDPWD="$initial_oldpwd"
 }
 
 
@@ -1137,7 +1298,7 @@ frozenrm() {
   local ids=()
   while read -r line; do
     printf '%s\n' "$line"
-    ids+=($(printf '%s\n' "$line" |gr frozen|awk '{print $3}'))
+    ids+=("$(printf '%s\n' "$line" |gr frozen|awk '{print $3}')")
   done < <(s mailq)
   echo "sleeping for 2 in case you change your mind"
   sleep 2
@@ -1235,6 +1396,7 @@ g() {
   if [[ $EMACSDIR ]]; then
     # Alter the path here, otherwise the nfs mount gets triggered on the
     # first path lookup when emacs is not being used.
+    # shellcheck disable=SC2098 disable=SC2097 # false positive
     PATH="$EMACSDIR/lib-src:$EMACSDIR/src:$PATH" EHOME=$HOME HOME=$EMACSDIR m emacsclient -a "" $args "$@"
   else
     if $gdb; then
@@ -1243,8 +1405,8 @@ g() {
       # m gdb -ex="set follow-fork-mode child" -ex=r -ex=quit --args emacs --daemon
       m emacsclient -a "" $args "$@"
       sleep 1
-      cd /a/opt/emacs-$(distro-name)$(distro-num)
-      s gdb -p $(pgrep -f 'emacs --daemon') -ex c
+      cd "/a/opt/emacs-$(distro-name)$(distro-num)"
+      s gdb -p "$(pgrep -f 'emacs --daemon')" -ex c
       cd -
     else
       m emacsclient -a "" $args "$@"
@@ -1284,9 +1446,22 @@ ccomp grep gr grr
 rg() { grr "$@"; }
 ccomp grep rg
 
-hr() { # horizontal row. used to break up output
-  printf "$(tput setaf 5 2>/dev/null ||:)█$(tput sgr0 2>/dev/null||:)%.0s" $(eval echo "{1..${COLUMNS:-60}}")
-  echo
+# recursive everything. search for files/dirs and lines. rs = easy chars to press
+re() {
+  local query
+  query="$1"
+  find "$@" -not \( -name .svn -prune -o -name .git -prune \
+       -o -name .hg -prune -o -name .editor-backups -prune \
+       -o -name .undo-tree-history -prune \) 2>/dev/null | grep -iP --color=auto "$query"
+  grr -m 5 "$@"
+}
+
+# horizontal row. used to break up output
+hr() {
+  local blocks
+  # 180 is long enough.
+  blocks=██████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████
+  printf "%s\n" "$(tput setaf 5 2>/dev/null ||:)${blocks:0:${COLUMNS:-180}}$(tput sgr0 2>/dev/null||:)"
 }
 # highlight
 hl() {
@@ -1297,6 +1472,7 @@ hl() {
   col=$((60 - input_len))
   printf "\e[1;97;41m%s" "$*"
   if (( col > 0 )); then
+    # shellcheck disable=SC2046 # needed to work as intended. a better way would be like hr above.
     printf "\e[1;97;41m \e[0m%.0s" $(eval echo "{1..${col}}")
   fi
   echo
@@ -1317,11 +1493,11 @@ hrcat() { local f; for f; do [[ -f $f ]] || continue; hr; echo "$f"; cat "$f"; d
 # On first use, you input username/pass and it gets an oath token so you dont have to repeat
 # it\'s at ~/.config/hub
 hub() {
-  local up uptar updir p v
+  local up uptar updir p re
   # example https://github.com/github/hub/releases/download/v2.14.2/hub-linux-amd64-2.14.2.tgz
   up=$(wget -q -O- https://api.github.com/repos/github/hub/releases/latest | jq -r .assets[].browser_download_url | grep linux-amd64)
   re='[[:space:]]'
-  if [[ ! $up || $up == $re ]]; then
+  if [[ ! $up || $up =~ $re ]]; then
     echo "failed to get good update url. got: $up"
   fi
   uptar=${up##*/}
@@ -1376,9 +1552,17 @@ ipp() {
   git push
 }
 
-
 ifn() {
-  # insensitive find
+  local glob
+  glob="$1"
+  shift
+  find -L "$@" -not \( -name .svn -prune -o -name .git -prune \
+       -o -name .hg -prune -o -name .editor-backups -prune \
+       -o -name .undo-tree-history -prune \) -iname "*$glob*" 2>/dev/null
+}
+
+ifh() {
+  # insensitive find here. args are combined into the search string.
   # -L = follow symlinks
   find -L . -not \( -name .svn -prune -o -name .git -prune \
        -o -name .hg -prune -o -name .editor-backups -prune \
@@ -1406,14 +1590,16 @@ pst() {
   pstree -apnA
 }
 
-jtail() {
-  journalctl -n 10000 -f "$@"
-}
-jr() { journalctl "$@" ; }
-jrf() { journalctl -f "$@" ; }
+# journalctl with times in the format the --since= and --until= options accept
+jrt() { journalctl -e -n100000 -o short-full "$@"; }
+jr() { journalctl -e -n100000 "$@" ; }
+jrf() { journalctl -n1000 -f "$@" ; }
 jru() {
-  journalctl -u exim4 _SYSTEMD_INVOCATION_ID=$(systemctl show -p InvocationID --value $1)
+  # the invocation id is "assigned each time the unit changes from an inactive
+  # state into an activating or active state" man systemd.exec
+  journalctl -e --no-tail -u exim4 _SYSTEMD_INVOCATION_ID="$(systemctl show -p InvocationID --value $1)"
 }
+ccomp journalctl jr jrf jru
 
 
 
@@ -1476,6 +1662,7 @@ low() {  # make filenames lowercase, remove bad chars
     fi
     f="${arg##*/}"
     new="${f,,}" # downcase
+    # shellcheck disable=SC2031 # seems like a shellcheck bug
     new="${new//[^a-zA-Z0-9._-]/_}" # sub bad chars
     new="${new#"${new%%[[:alnum:]]*}"}" # remove leading/trailing non-alnum
     new="${new%"${new##*[[:alnum:]]}"}"
@@ -1513,14 +1700,19 @@ ksu() { # history search unique
 # inexplicably truncated in the past.
 histrm() {
   history -n
-  HISTTIMEFORMAT= history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/'
-  read -p "press anything but contrl-c to delete"
-  for entry in $(HISTTIMEFORMAT= history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/ { print a }' | tac); do
+  HISTTIMEFORMAT='' history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/'
+  read -r -p "press anything but contrl-c to delete"
+  for entry in $(HISTTIMEFORMAT='' history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/ { print a }' | tac); do
     history -d $entry
   done
   history -w
 }
 
+# history without the date
+histplain() {
+  history "$@" | cut -d' ' -f 7-
+}
+
 ccomp grep k ks ksu histrm
 
 
@@ -1536,7 +1728,16 @@ mkc() {
 ccomp mkdir mkc
 
 mkct() {
-  mkc $(mktemp -d)
+  mkc "$(mktemp -d)"
+}
+# mkdir the last arg, cp the rest into it
+mkcp() {
+  mkdir -p "${@: -1}"
+  cp "${@:1:$#-1}" "${@: -1}"
+}
+mkmv() {
+  mkdir -p "${@: -1}"
+  mv "${@:1:$#-1}" "${@: -1}"
 }
 
 mkt() { # mkdir and touch file
@@ -1550,12 +1751,24 @@ mkdir() { command mkdir -p "$@"; }
 
 nags() {
   # https://github.com/HenriWahl/Nagstamon/issues/357
-  if ! pgrep -f /usr/lib/notification-daemon/notification-daemon >/dev/null; then
-    /usr/lib/notification-daemon/notification-daemon &
+  if ! pgrep -f /usr/bin/dunst >/dev/null; then
+    /usr/bin/dunst &
   fi
   /usr/bin/nagstamon &
 }
 
+# profanity screen
+profsrc() {
+  screen -RD -S profanity
+}
+
+# i dont want to wait for konsole to exit...
+prof() {
+  command prof &>/dev/null &
+}
+
+
+
 nmt() {
   # cant use s because sudo -i doesnt work for passwordless sudo command
   case $EUID in
@@ -1604,7 +1817,7 @@ p6() { ping6 "$@" 2001:4860:4860::8888; }
 
 pkx() { # package extract
   local pkg cached tmp f
-  c $(mktemp -d)
+  c "$(mktemp -d)"
   pkg=$1
   # shellcheck disable=SC2012
   cached=$(ls -t /var/cache/apt/archives/$pkg* | tail -n1 2>/dev/null) ||:
@@ -1620,19 +1833,21 @@ pkx() { # package extract
 
 # pgrep and kill
 pk1() {
-  local pid
-  pid=($(pgrep -f "$*"))
-  case ${#pid[@]} in
+  local tmpf
+  local -a pids
+  tmpf=$(pgrep -f "$*")
+  mapfile -t pids <<<"$tmpf"
+  case ${#pids[@]} in
     1)
       # shellcheck disable=SC2128
       {
-        ps -F $pid
-        m kill $pid
+        ps -F ${pids[0]}
+        m kill ${pids[0]}
       }
       ;;
     0) echo "no pid found" ;;
     *)
-      ps -F ${pid[@]}
+      ps -F ${pids[@]}
       ;;
   esac
 }
@@ -1676,7 +1891,7 @@ r() {
 
 # scp is insecure and deprecated.
 scp() {
-  rsync --inplace "$@"
+  rsync -Pt --inplace "$@"
 }
 ccomp rsync scp
 
@@ -1691,6 +1906,7 @@ EOF
 
 # reapply bashrc
 reb() {
+  # shellcheck disable=SC1090 # expected to not follow
   source ~/.bashrc
 }
 
@@ -1783,6 +1999,11 @@ reresolv() {
   fi
 }
 
+# add annoyingly long argument which should be the default
+sedi() {
+  sed -i --follow-symlinks "$@"
+}
+
 rmstrips() {
   ssh fencepost head -n 300 /gd/gnuorg/EventAndTravelInfo/rms-current-trips.txt | less
 }
@@ -1827,7 +2048,7 @@ ccomp sudo s sb se
 safe_rename() { # warn and dont rename if file exists.
   # mv -n exists, but it\'s silent
   if [[ $# != 2 ]]; then
-    echo safe_rename error: $# args, need 2 >2
+    echo safe_rename error: $# args, need 2 >&2
     return 1
   fi
   if [[ $1 != "$2" ]]; then # yes, we want to silently ignore this
@@ -1873,7 +2094,7 @@ setini() { # set a value in a .ini style file
   if [[ -s $file ]]; then
     sed -ri -f - "$file" <<EOF
 # remove existing keys
-/ *\[$section\]/,/^ *\[[^]]+\]/{/^\s*$key[[:space:]=]/d}
+/ *\[$section\]/,/^ *\[[^]]+\]/{/^\s*${key}[[:space:]=]/d}
 # add key
 /^\s*\[$section\]/a $key=$value
 # from section to eof, do nothing
@@ -1913,19 +2134,32 @@ sgu() {
 
 
 sk() {
-
-
   # disable a warning with:
   # shellcheck disable=SC2206 # reasoning
 
   # see bash-template/style-guide.md for justifications
 
   local quotes others
-  quotes=2048,2068,2086,2206
+  quotes=2048,2068,2086,2206,2254
   others=2029,2033,2054,2164
   shellcheck -W 999 -x -e $quotes,$others "$@" || return $?
 }
+# sk with quotes. For checking scripts that we expect to take untrusted
+# input in order to verify we quoted vars.
+skq() {
+  local others
+  others=2029,2033,2054,2164
+  shellcheck -W 999 -x -e $others "$@" || return $?
+}
 
+skgit() {
+  local f
+  for f in $(i s | awk '$1 == "modified:" {print $2}'); do
+    if [[ $(head -n1 "$f") == '#!/bin/bash'* ]]; then
+      sk $f ||:
+    fi
+  done
+}
 
 # sl: ssh, but firsh rsync our bashrc and related files to a special
 # directory on the remote host if needed.
@@ -2010,9 +2244,11 @@ sl() {
     force_rsync=true
     shift
   fi
-
+  # shellcheck disable=SC2153 # intentional
   sl_test_cmd=$SL_TEST_CMD
+  # shellcheck disable=SC2153 # intentional
   sl_test_hook=$SL_TEST_HOOK
+  # shellcheck disable=SC2153 # intentional
   sl_rsync_args=$SL_RSYNC_ARGS
   while [[ $1 ]]; do
     case "$1" in
@@ -2065,7 +2301,7 @@ sl() {
   shift
 
   if [[ ! $SL_INFO_DIR  ]]; then
-    echo error: missing '$SL_INFO_DIR' env var >&2
+    echo 'error: missing SL_INFO_DIR env var' >&2
     return 1
   fi
 
@@ -2107,7 +2343,7 @@ sl() {
 
   if $haveinfo && [[ $type == b ]]; then
     info_sec=${tmp::10}
-    read files_sec _ < <(find -L $SL_FILES_DIR -printf "%T@ %p\n" | sort -nr || [[ $? == 141 || ${PIPESTATUS[0]} == 32 ]]  )
+    read -r files_sec _ < <(find -L $SL_FILES_DIR -printf "%T@ %p\n" | sort -nr || [[ $? == 141 || ${PIPESTATUS[0]} == 32 ]]  )
     files_sec=${files_sec%%.*}
     if (( files_sec > info_sec )); then
       dorsync=true
@@ -2118,7 +2354,7 @@ sl() {
   sync_dirname=${SL_FILES_DIR##*/}
 
   if [[ ! $SL_FILES_DIR  ]]; then
-    echo error: missing '$SL_FILES_DIR' env var >&2
+    echo 'error: missing SL_FILES_DIR env var' >&2
     return 1
   fi
 
@@ -2188,8 +2424,12 @@ slog() {
   while getopts "lt" option
   do
     case $option in
-      l ) arg_base=$logdir ;;
-      t ) do_stamp=true ;;
+      l) arg_base=$logdir ;;
+      t) do_stamp=true ;;
+      *)
+        echo error: bad option
+        return 1
+        ;;
     esac
   done
   shift $((OPTIND - 1))
@@ -2220,7 +2460,7 @@ srm () {
 
 srun() {
   scp $2 $1:/tmp
-  ssh $1 /tmp/${2##*/} $(printf "%q\n" "${@:2}")
+  ssh $1 "/tmp/${2##*/}" "$(printf "%q\n" "${@:2}")"
 }
 
 
@@ -2282,15 +2522,23 @@ psoff() {
   # however, DEBUG is not inherited, so we need to run it outside a function.
   # And we want to run set -x afterwards to avoid spam, so we cram everything
   # in here, and then it will run after this function is done.
-  PROMPT_COMMAND='trap DEBUG; unset PROMPT_COMMAND; PS1="\w \$ "'
+  # # set as array to satisfy shellcheck, but it is equivalent to setting it as non-array
+  PROMPT_COMMAND=('trap DEBUG; unset PROMPT_COMMAND; PS1="\w \$ "')
 }
 pson() {
-  PROMPT_COMMAND=prompt-command
+  PROMPT_COMMAND=(prompt-command)
   if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
     trap 'settitle "$BASH_COMMAND"' DEBUG
   fi
 }
 
+# prometheus node curl
+pnodecurl() {
+  local host
+  host=${1:-127.0.0.1}
+  s curl --cert-type PEM --cert /etc/prometheus/ssl/prometheus_cert.pem --key /etc/prometheus/ssl/prometheus_key.pem --cacert /etc/prometheus/ssl/prom_node_cert.pem --resolve prom_node:9100:$host -v https://prom_node:9100/metrics
+}
+
 tx() { # toggle set -x, and the prompt so it doesnt spam
   if [[ $- == *x* ]]; then
     set +x
@@ -2321,7 +2569,9 @@ nonet() {
 
 m() { printf "%s\n" "$*";  "$@"; }
 
-# update file. note: duplicated in mail-setup
+# update file. note: duplicated in mail-setup.
+# updates $ur u result to true or false
+# updates $reload to true if file updated is in /etc/systemd/system
 u() {
   local tmp tmpdir dest="$1"
   local base="${dest##*/}"
@@ -2330,14 +2580,17 @@ u() {
     # dest has a directory component
     mkdir -p "$dir"
   fi
+  # shellcheck disable=SC2034 # see comment at top of function
   ur=false # u result
-  tmpdir=$(mktemp -d)
+  tmpdir="$(mktemp -d)"
   cat >$tmpdir/"$base"
   tmp=$(rsync -ic $tmpdir/"$base" "$dest")
   if [[ $tmp ]]; then
     printf "%s\n" "$tmp"
+    # shellcheck disable=SC2034 # see comment at top of function
     ur=true
     if [[ $dest == /etc/systemd/system/* ]]; then
+      # shellcheck disable=SC2034 # see comment at top of function
       reload=true
     fi
   fi
@@ -2397,7 +2650,7 @@ zr() {
   local tmp
   tmp=$(type -p "$1")
   if [[ $tmp ]]; then
-    cd $(mktemp -d)
+    cd "$(mktemp -d)"
     cp -a "$tmp" .
     shift
     ./"${tmp##*/}" "$@"
@@ -2462,11 +2715,40 @@ spark()
 
   for n in $numbers
   do
-    _spark_echo -n ${ticks[$(( ((($n-$min)<<8)/$f) ))]}
+    _spark_echo -n ${ticks[$(( (((n-min)<<8)/f) ))]}
   done
   _spark_echo
 }
 
+pdfwc() { local f; for f; do echo "$f" "$(pdfinfo "$f" | awk '/^Pages:/ {print $2}')"; done }
+
+
+# nvm install script appended this to my .bashrc. I dont want to run it all the time,
+# so put it in a function.
+nvm-init() {
+  export NVM_DIR="$HOME/.nvm"
+  # shellcheck disable=SC1091 # may not exist, & third party
+  [ -s "$NVM_DIR/nvm.sh" ] && source "$NVM_DIR/nvm.sh"  # This loads nvm
+  # shellcheck disable=SC1091 # may not exist, & third party
+  [ -s "$NVM_DIR/bash_completion" ] && source "$NVM_DIR/bash_completion"  # This loads nvm bash_completion
+}
+
+
+leap-year() {
+  if date -d 'february 29' &>/dev/null; then
+    year_days=366
+  else
+    year_days=365
+  fi
+  echo $year_days
+}
+
+# on-battery
+on-bat() {
+  if [[ -e /sys/class/power_supply/AC/online && $(</sys/class/power_supply/AC/online) == 0 ]]; then
+    return 1
+  fi
+}
 
 # * misc stuff
 
@@ -2475,6 +2757,7 @@ if $use_color && type -p tput &>/dev/null; then
   term_bold="$(tput bold)"
   term_red="$(tput setaf 1)"
   term_green="$(tput setaf 2)"
+  # shellcheck disable=SC2034 # expected
   term_yellow="$(tput setaf 3)"
   term_purple="$(tput setaf 5)"
   term_nocolor="$(tput sgr0)" # no font attributes
@@ -2548,11 +2831,15 @@ if [[ $- == *i* ]]; then
 
     # faster than sourceing the file im guessing
     if [[ -e /dev/shm/iank-status && ! -e /tmp/quiet-status ]]; then
-      eval $(< /dev/shm/iank-status)
+      eval "$(< /dev/shm/iank-status)"
     fi
     if [[ $MAIL_HOST && $MAIL_HOST != "$HOSTNAME" ]]; then
       ps_char="@ $ps_char"
     fi
+    jobs_char=
+    if [[ $(jobs -p) ]]; then
+      jobs_char='j\j '
+    fi
     # We could test if sudo is active with sudo -nv
     # but then we get an email and log of lots of failed sudo commands.
     # We could turn those off, but seems better not to.
@@ -2562,13 +2849,13 @@ if [[ $- == *i* ]]; then
     if [[ ! $HISTFILE ]]; then
       ps_char="NOHIST $ps_char"
     fi
-    PS1="${PS1%"${PS1#*[wW]}"} $psudo\[$ps_color\]$ps_char\[$term_nocolor\] "
+    PS1="${PS1%"${PS1#*[wW]}"} $jobs_char$psudo\[$ps_color\]$ps_char\[$term_nocolor\] "
 
     # set titlebar. instead, using more advanced
     # titelbar below
     #echo -ne "$_title_escape $HOSTNAME ${PWD/#$HOME/~}  \007"
   }
-  PROMPT_COMMAND=prompt-command
+  PROMPT_COMMAND=(prompt-command)
 
   if [[ $TERM == screen* ]]; then
     _title_escape="\033]..2;"
@@ -2578,18 +2865,22 @@ if [[ $- == *i* ]]; then
     _title_escape="\033]0;"
   fi
 
+  # make the titlebar be the last command and the current directory.
   settitle () {
-    # this makes it so we show the current command if
-    # one is running, otherwise, show nothing
 
-    if [[ $1 == prompt-command ]]; then
+
+    # These are some checks to help ensure we dont set the title at
+    # times that the debug trap is running other than the case we
+    # want. Some of them might not be needed.
+    if (( ${#FUNCNAME[@]} != 1 || ${#BASH_ARGC[@]} != 2 || BASH_SUBSHELL != 0 )); then
       return 0
     fi
-    if (( ${#BASH_ARGC[@]} == 1 && BASH_SUBSHELL == 0 )); then
-      echo -ne "$_title_escape ${PWD/#$HOME/~} "
-      printf "%s" "$*"
-      echo -ne "\007"
+    if [[ $1 == prompt-command ]]; then
+      return 0
     fi
+    echo -ne "$_title_escape ${PWD/#$HOME/~} "
+    printf "%s" "$*"
+    echo -ne "\007"
   }
 
   # note, this wont work:
@@ -2613,8 +2904,10 @@ fi
 # best practice
 unset IFS
 
-# shellcheck disable=SC1090
-[[ -s "$HOME/.rvm/scripts/rvm" ]] && source "$HOME/.rvm/scripts/rvm" # Load RVM into a shell session *as a function*
+if [[ -s "$HOME/.rvm/scripts/rvm" ]]; then
+  # shellcheck disable=SC1091
+  source "$HOME/.rvm/scripts/rvm"
+fi
 
 # I had this idea to start a bash shell which would run an initial
 # command passed through this env variable, then continue on